#!/usr/bin/python2

"""    Multipeer, Copyright 2003 Andreas Bergstrm and Audun Vaaler

    This file is part of Multipeer.
    
    Multipeer is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    You should have received a copy of the GNU General Public License
    along with Foobar; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA"""

import socket, IPy, string, struct, sys

def createUnicastSocket(address, port):
    #As we do not yet know wheter the address is IPv4 or IPv6, we do not
    #specify AF as yet.

    s = None

    for res in socket.getaddrinfo(address, port, socket.AF_UNSPEC, socket.SOCK_STREAM, 0, socket.AI_PASSIVE):
        af, socktype, proto, cannonname, sa = res
        try:
            s = socket.socket(af, socktype, proto)
        except socker.error, msg:
            s = None
            continue
        try:
            s.bind(sa)
            s.listen(1)
        except socket.error, msg:
            print "Error, could not open socket %s (%s), %s %s!" % (socket.error, msg, address, port)
            s.close()
            s = None
            continue
        break
    if s is None:
        print "Error! createUnicastSocket, could not open socket!"

    s.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
    return s

def createUnicastClientSocket(address, port):
    #Dual stack implementation
    s = None
    for res in socket.getaddrinfo(address, port, socket.AF_UNSPEC, socket.SOCK_STREAM):
        af, socktype, proto, canonname, sa = res
        try:
            s = socket.socket(af, socktype, proto)
        except socket.error, msg:
            s = None
            continue
        try:
            s.connect(sa)
        except socket.error, msg:
            print "Error, could not open soccket %s (%s), %s %s" % (socket.error, msg, address, port)
            s.close()
            s = None
            continue
        break
    if s is None:
        print "Error! createUnicastClientSocket, could not open socket!"

    s.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
    return s

def createMulticastSocket(address, port, ttl=255):
    # As we do not yet know wheter the address is IPv4 or IPv6 we specify AF_UNSPEC for now
    group = socket.getaddrinfo(address, None, socket.AF_UNSPEC, socket.SOCK_DGRAM)
    
    # Clear grpaddr
    grpaddr = ""

    port = int(port)
    
    # Check wheter it is IPv4 or IPv6
    #
    # Todo: Need better handling of the tuple
    # Todo: Must be better way to create mreq
    # Todo: Need to find better Python version of getaddrinfo()
    if (group[0][0] == socket.AF_INET6):
        grp = IPy.IP(address)
        words = string.split(grp.strNormal(), ":")
        for word in words:
            word = int(word, 16)
            grpaddr = grpaddr + struct.pack("!h", word)
        ifaddr = socket.INADDR_ANY
        mreq = grpaddr + struct.pack("!I", ifaddr)
    else:
        # IPv4 and IPv4 mreq creation
        #grp = IPy.IP(address)
        #bytes = string.split(grp.strNormal(), ".")
        bytes = string.split(address, ".")
        grpaddr = 0
        for byte in bytes:
            byte = int(byte)
            grpaddr = (grpaddr << 8) | byte
        ifaddr = socket.INADDR_ANY
        mreq = struct.pack("!LL", grpaddr, ifaddr)
                
    if (group[0][0] == socket.AF_INET6):
        # Set IPv6 socket options
        s = socket.socket(socket.AF_INET6, socket.SOCK_DGRAM)
        s.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
        s.bind(("", port))
        s.setsockopt(socket.IPPROTO_IPV6, socket.IPV6_JOIN_GROUP, mreq)
        s.setsockopt(socket.IPPROTO_IPV6, socket.IPV6_MULTICAST_LOOP, 0)
        s.setsockopt(socket.IPPROTO_IPV6, socket.IPV6_MULTICAST_HOPS, ttl)
    else:
        # Set IPv4 socket options
        s= socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
        s.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
        s.bind(("", port))
        s.setsockopt(socket.IPPROTO_IP, socket.IP_ADD_MEMBERSHIP, mreq)
        s.setsockopt(socket.IPPROTO_IP, socket.IP_MULTICAST_TTL, ttl)
        s.setsockopt(socket.IPPROTO_IP, socket.IP_MULTICAST_LOOP, 0)
        
    return s
